// testtransferDlg.h : header file
//

#if !defined(AFX_TESTTRANSFERDLG_H__096924C0_3954_42D1_9945_1F0E9839639A__INCLUDED_)
#define AFX_TESTTRANSFERDLG_H__096924C0_3954_42D1_9945_1F0E9839639A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CTesttransferDlg dialog
typedef struct _tagTransDev
{
	CString strip[10];
	int port[10];
	int validcount;
}TRANSDEV;

typedef struct _tagClient
{
	TRANSDEV dev;
	HANDLE hDTU;
}CLIENT;

class CTesttransferDlg : public CDialog
{
// Construction
public:
	void RefreshTransDev();
	void ClearClients();
	HANDLE m_hServer;
	CTesttransferDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CTesttransferDlg)
	enum { IDD = IDD_TESTTRANSFER_DIALOG };
	CListCtrl	m_ctlListTransDev;
	CListCtrl	m_ctlListClient;
    CButton     m_RadioDec;
    CButton     m_RadioHex;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTesttransferDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

    void TranslateStringToDec(CString &cstr);

	// Generated message map functions
	//{{AFX_MSG(CTesttransferDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnButtonServer();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnClickListClient(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnButtonAdd();
    afx_msg void OnTransfer();
	afx_msg void OnClearSource();
	afx_msg void OnClearDes();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TESTTRANSFERDLG_H__096924C0_3954_42D1_9945_1F0E9839639A__INCLUDED_)
