// testconfigDlg.cpp : implementation file
//

#include "stdafx.h"
#include "testconfig.h"
#include "testconfigDlg.h"
#include "dtucfgheader.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestconfigDlg dialog

CTestconfigDlg::CTestconfigDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestconfigDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestconfigDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bEnterConfig=0;
	m_hDTU=NULL;
}

void CTestconfigDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestconfigDlg)
	DDX_Control(pDX, IDC_COMBO_COMSTOPBITS, m_ctlComboCOMStopBits);
	DDX_Control(pDX, IDC_COMBO_COMDATABITS, m_ctlComboCOMDataBits);
	DDX_Control(pDX, IDC_COMBO_COMCHECKBITS, m_ctlComboCOMCheckBits);
	DDX_Control(pDX, IDC_COMBO_COMBAUD, m_ctlComboCOMBaud);
	DDX_Control(pDX, IDC_COMBO_MODE, m_ctlComboMode);
	DDX_Control(pDX, IDC_COMBO_STOPBITS, m_ctlComboStopBits);
	DDX_Control(pDX, IDC_COMBO_DATABITS, m_ctlComboDataBits);
	DDX_Control(pDX, IDC_COMBO_COM, m_ctlComboCom);
	DDX_Control(pDX, IDC_COMBO_CHECKBITS, m_ctlComboCheckBits);
	DDX_Control(pDX, IDC_COMBO_BAUD, m_ctlComboBaud);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestconfigDlg, CDialog)
	//{{AFX_MSG_MAP(CTestconfigDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_ENTERCFG, OnButtonEntercfg)
	ON_BN_CLICKED(IDC_BUTTON_EXITCONFIG, OnButtonExitconfig)
	ON_BN_CLICKED(IDC_BUTTON_GETINFO, OnButtonGetinfo)
	ON_BN_CLICKED(IDC_BUTTON_MODIFYID, OnButtonModifyid)
	ON_BN_CLICKED(IDC_BUTTON_MODIFYPHONE, OnButtonModifyphone)
	ON_BN_CLICKED(IDC_BUTTON_MODIFYMODE, OnButtonModifymode)
	ON_BN_CLICKED(IDC_BUTTON_MODIFYBAUD, OnButtonModifybaud)
	ON_BN_CLICKED(IDC_BUTTON_MODIFYDATABITS, OnButtonModifydatabits)
	ON_BN_CLICKED(IDC_BUTTON_MODIFYSTOPBITS, OnButtonModifystopbits)
	ON_BN_CLICKED(IDC_BUTTON_MODIFYCHECKBITS, OnButtonModifycheckbits)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestconfigDlg message handlers

BOOL CTestconfigDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	InitCom();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestconfigDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestconfigDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestconfigDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTestconfigDlg::OnOK() 
{
	// TODO: Add extra validation here
	
//	CDialog::OnOK();
}

void CTestconfigDlg::InitCom()
{
	// m_ctlComboCom.AddString("COM1");
	// m_ctlComboCom.AddString("COM2");
	// m_ctlComboCom.AddString("COM3");
	// m_ctlComboCom.AddString("COM4");

    for ( int n = 0; n < 50; n++ ) {
        CString strTmp = "";

        strTmp.Format( "COM%d", n+1 );
        m_ctlComboCom.AddString( strTmp );
    }

	m_ctlComboCom.SetCurSel(0);

	int baudarr[]={300,600,1200,2400,4800,9600,19200,38400,57600,115200};
	CString str;
	for(int i=0;i<sizeof(baudarr)/sizeof(int);i++)
	{
		str.Format("%d",baudarr[i]);
		int ind=m_ctlComboBaud.AddString(str);
		m_ctlComboBaud.SetItemData(ind,baudarr[i]);
	}
	m_ctlComboBaud.SetCurSel(5);
	
	int dataarr[]={5,6,7,8};
	for(i=0;i<sizeof(dataarr)/sizeof(int);i++)
	{
		str.Format("%d",dataarr[i]);
		int ind=m_ctlComboDataBits.AddString(str);
		m_ctlComboDataBits.SetItemData(ind,dataarr[i]);
	}
	m_ctlComboDataBits.SetCurSel(3);

	int stoparr[]={1,2};
	for(i=0;i<sizeof(stoparr)/sizeof(int);i++)
	{
		str.Format("%d",stoparr[i]);
		int ind=m_ctlComboStopBits.AddString(str);
		m_ctlComboStopBits.SetItemData(ind,stoparr[i]);
	}
	m_ctlComboStopBits.SetCurSel(0);

	m_ctlComboCheckBits.SetItemData(m_ctlComboCheckBits.AddString(""),0);
	m_ctlComboCheckBits.SetItemData(m_ctlComboCheckBits.AddString("У"),1);
	m_ctlComboCheckBits.SetItemData(m_ctlComboCheckBits.AddString("żУ"),2);
	m_ctlComboCheckBits.SetItemData(m_ctlComboCheckBits.AddString("ǿΪ1"),3);
	m_ctlComboCheckBits.SetItemData(m_ctlComboCheckBits.AddString("ǿΪ0"),4);
	m_ctlComboCheckBits.SetCurSel(0);

	m_ctlComboMode.SetCurSel(0);
	m_ctlComboCOMBaud.SetCurSel(8);
	m_ctlComboCOMDataBits.SetCurSel(3);
	m_ctlComboCOMCheckBits.SetCurSel(0);
	m_ctlComboCOMStopBits.SetCurSel(0);
}

void CTestconfigDlg::OnButtonEntercfg() 
{
	// TODO: Add your control notification handler code here
	AddCom();
	int res=DTU_Init(m_hDTU);
	if(!res||!DTU_EnterConfig(m_hDTU))
	{
		DTU_Delete(m_hDTU);
		m_hDTU=NULL;
		if(!res)
			ShowErr("޷򿪴");
		else
			ShowErr("޷豸");
		return;
	}
	m_bEnterConfig=1;
	SetBtnState(m_bEnterConfig);	
}

void CTestconfigDlg::ShowErr(LPCTSTR lpmsg)
{
	MessageBox(lpmsg,"",MB_ICONSTOP|MB_OK);
}

void CTestconfigDlg::AddCom()
{
	if(m_hDTU!=NULL)
	{
		DTU_Delete(m_hDTU);
		m_hDTU=NULL;
	}
	int comind=m_ctlComboCom.GetCurSel()+1;
	int baud=m_ctlComboBaud.GetItemData(m_ctlComboBaud.GetCurSel());
	int databits=m_ctlComboDataBits.GetItemData(m_ctlComboDataBits.GetCurSel());
	int stopbits=m_ctlComboStopBits.GetItemData(m_ctlComboStopBits.GetCurSel());
	int checkbits=m_ctlComboCheckBits.GetCurSel();
	m_hDTU=DTU_AddCOM(comind,baud,databits,checkbits,stopbits);
}

void CTestconfigDlg::OnButtonExitconfig() 
{
	// TODO: Add your control notification handler code here
	HANDLE predtu=m_hDTU;
	if(m_hDTU==NULL)
		AddCom();

	if(predtu==NULL&&!DTU_Init(m_hDTU))
	{
		DTU_Delete(m_hDTU);
		m_hDTU=NULL;
		ShowErr("޷豸");
		m_bEnterConfig=0;
		SetBtnState(m_bEnterConfig);
		return;
	}

	if(!DTU_ExitConfig(m_hDTU))
	{
		ShowErr("ʧ");
	}
	m_bEnterConfig=0;
	SetBtnState(m_bEnterConfig);
	DTU_Delete(m_hDTU);	
	m_hDTU=NULL;	
}

void CTestconfigDlg::SetBtnState(int started)
{
	GetDlgItem(IDC_BUTTON_ENTERCFG)->EnableWindow(!started);
	m_bEnterConfig=started;
}

void CTestconfigDlg::OnButtonGetinfo() 
{
	// TODO: Add your control notification handler code here
	if(!IsInCfg())
		return;
	if(!DTU_GetAllConfig(m_hDTU))
	{
		ShowErr("ȡϢʧ");
		return;
	}
	char szcmd[20],szval[50];
	CString strinfo="ȡϢ:\r\n\r\n";
	while(DTU_GetConfig(m_hDTU,szcmd,szval))
	{
		FillInfo(szcmd,szval);
		strinfo+=":";
		strinfo+=szcmd;
		strinfo+="   ֵ:";
		strinfo+=szval;
		strinfo+="\r\n";
	}
	MessageBox(strinfo);
}

int CTestconfigDlg::IsInCfg()
{
	if(!m_bEnterConfig)
		ShowErr("Ƚ״̬");
	return m_bEnterConfig;
}

void CTestconfigDlg::FillInfo(char *szcmd, char *szval)
{
	if(!strcmp(szcmd,CMD_DTUID))
	{
		GetDlgItem(IDC_EDIT_DEVID)->SetWindowText(szval);
	}
	else if(!strcmp(szcmd,CMD_PHON))
	{
		GetDlgItem(IDC_EDIT_PHONE)->SetWindowText(szval);
	}
	else if(!strcmp(szcmd,CMD_MODE))
	{
		m_ctlComboMode.SelectString(0,(LPCTSTR)szval);
	}
	else if(!strcmp(szcmd,CMD_SERBAUD))
	{
		m_ctlComboCOMBaud.SelectString(0,(LPCTSTR)szval);
	}
	else if(!strcmp(szcmd,CMD_SERDAT))
	{
		m_ctlComboCOMDataBits.SelectString(0,(LPCTSTR)szval);
	}
	else if(!strcmp(szcmd,CMD_SERSTP))
	{
		m_ctlComboCOMStopBits.SelectString(0,(LPCTSTR)szval);
	}
	else if(!strcmp(szcmd,CMD_SERCHK))
	{
		m_ctlComboCOMCheckBits.SetCurSel(atoi(szval));
	}
	
}

void CTestconfigDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	if(m_bEnterConfig)
	{
		DTU_ExitConfig(m_hDTU,0);
		DTU_Uninit(m_hDTU);
		DTU_Delete(m_hDTU);
		m_bEnterConfig=0;
	}
	CDialog::OnCancel();
}

void CTestconfigDlg::OnButtonModifyid() 
{
	// TODO: Add your control notification handler code here
	if(!IsInCfg())
		return;
	char szval[200];
	GetDlgItem(IDC_EDIT_DEVID)->GetWindowText(szval,200);
	if(DTU_ConfigWrite(m_hDTU,CMD_DTUID,szval)!=1)
	{
		ShowErr("ʧ");
	}
}

void CTestconfigDlg::OnButtonModifyphone() 
{
	// TODO: Add your control notification handler code here
	if(!IsInCfg())
		return;
	char szval[200];
	GetDlgItem(IDC_EDIT_PHONE)->GetWindowText(szval,200);
	if(DTU_ConfigWrite(m_hDTU,CMD_PHON,szval)!=1)
	{
		ShowErr("ʧ");
	}
	
}

void CTestconfigDlg::OnButtonModifymode() 
{
	// TODO: Add your control notification handler code here
	if(!IsInCfg())
		return;
	char szval[200];
	GetDlgItem(IDC_COMBO_MODE)->GetWindowText(szval,200);
	if(DTU_ConfigWrite(m_hDTU,CMD_MODE,szval)!=1)
	{
		ShowErr("ʧ");
	}	
}

void CTestconfigDlg::OnButtonModifybaud() 
{
	// TODO: Add your control notification handler code here
	if(!IsInCfg())
		return;
	char szval[200];
	GetDlgItem(IDC_COMBO_COMBAUD)->GetWindowText(szval,200);
	if(DTU_ConfigWrite(m_hDTU,CMD_SERBAUD,szval)!=1)
	{
		ShowErr("ʧ");
	}	
	
}

void CTestconfigDlg::OnButtonModifydatabits() 
{
	// TODO: Add your control notification handler code here
	if(!IsInCfg())
		return;
	char szval[200];
	GetDlgItem(IDC_COMBO_COMDATABITS)->GetWindowText(szval,200);
	if(DTU_ConfigWrite(m_hDTU,CMD_SERDAT,szval)!=1)
	{
		ShowErr("ʧ");
	}	
	
}

void CTestconfigDlg::OnButtonModifystopbits() 
{
	// TODO: Add your control notification handler code here
	if(!IsInCfg())
		return;
	char szval[200];
	GetDlgItem(IDC_COMBO_COMSTOPBITS)->GetWindowText(szval,200);
	if(DTU_ConfigWrite(m_hDTU,CMD_SERSTP,szval)!=1)
	{
		ShowErr("ʧ");
	}	
}

void CTestconfigDlg::OnButtonModifycheckbits() 
{
	// TODO: Add your control notification handler code here
	if(!IsInCfg())
		return;
	char szval[200];
	sprintf(szval,"%d",m_ctlComboCOMCheckBits.GetCurSel());
	if(DTU_ConfigWrite(m_hDTU,CMD_SERCHK,szval)!=1)
	{
		ShowErr("ʧ");
	}		
}
