//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "dtucfgheader.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  ComboBox_Mode->ItemIndex= 0;
  ComboBox_COMBaud->ItemIndex= 9;
  ComboBox_COMDataBits->ItemIndex= 3;
  ComboBox_COMStopBits->ItemIndex= 0;
  ComboBox_COMCheckBits->ItemIndex= 0;

  m_hDTU=0;
  m_hServerDTU=0;
  SetBtnState ();


}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnClose(TObject *Sender, TCloseAction &Action)
{
        if(m_hServerDTU!=0)
	        Button_ServerClick(Sender);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_EnterCfgClick(TObject *Sender)
{
 	if(DTU_EnterConfig(m_hDTU)==0)
    {
		ShowMessage("޷豸");
		return;
	}
	m_bEnterConfig=1;
	SetBtnState();
}
//---------------------------------------------------------------------------


void TForm1::AddClient(HANDLE hClient,char* szip,int port,char* sztype,char* szid,char* szphone)
{
	if(m_hDTU!=0)
	{
		if(m_bEnterConfig==1)
			DTU_ExitConfig(m_hDTU,0);
		DTU_Uninit(m_hDTU);
		DTU_Delete(m_hDTU);
		m_hDTU=0;
		m_bEnterConfig=0;
	}
	m_hDTU=hClient;

  AnsiString strinfo=
	"ͻ: IPַ:"+AnsiString(szip)+" ˿:"+IntToStr(port)+" :"+sztype+" 豸ID:"+szid+" ֻ:"+szphone;
  Label_Client->Caption=strinfo;
	SetBtnState();
}

void TForm1::SetBtnState()
{
  if(m_hServerDTU==0)
    Button_Server->Caption="";
  else
    Button_Server->Caption="ֹͣ";

  if(m_hDTU!=0&&m_bEnterConfig==0)
    Button_EnterCfg->Enabled=True;
  else
    Button_EnterCfg->Enabled=False;

    Button_ExitCfg->Enabled=(m_hDTU!=0);

    Button_GetInfo->Enabled=(m_hDTU!=0&&m_bEnterConfig);

    if(m_hDTU==0)
        Label_Client->Caption="";

}

void __fastcall TForm1::Button_ExitCfgClick(TObject *Sender)
{
	if(DTU_ExitConfig(m_hDTU,1)==0)
		ShowMessage("ʧ");
	m_bEnterConfig=0;
	SetBtnState();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button_GetInfoClick(TObject *Sender)
{
    if(IsInCfg()==0)
        return;
    if(DTU_GetAllConfig(m_hDTU)==0)
    {
        ShowMessage("ȡϢʧ");
        return;
    }
    AnsiString strinfo="ȡϢ:\r\n\r\n";
    char szcmd[20],szval[20];
    while(DTU_GetConfig(m_hDTU, szcmd, szval)==1)
    {
        FillInfo(szcmd, szval);
        strinfo= strinfo + ":";
        strinfo= strinfo +szcmd;
        strinfo= strinfo + "   ֵ:";
        strinfo= strinfo + szval;
        strinfo= strinfo +"\r\n";
    }
    ShowMessage(strinfo);

}
//---------------------------------------------------------------------------


int TForm1::IsInCfg()
{
    if(m_bEnterConfig ==0)
        ShowMessage("Ƚ״̬");

    return m_bEnterConfig;
}

void TForm1::FillInfo(char* szcmd, char* szval)
{
    if(StrComp(szcmd, CMD_DTUID) ==0)
        Edit_DevID->Text= szval;
    else if(StrComp(szcmd, CMD_PHON) ==0)
        Edit_Phone->Text= szval;
    else if(StrComp(szcmd, CMD_MODE) ==0)
        ComboBox_Mode->Text= szval;
    else if(StrComp(szcmd, CMD_SERBAUD) ==0)
        ComboBox_COMBaud->Text= szval;
    else if(StrComp(szcmd, CMD_SERDAT) == 0)
        ComboBox_COMDataBits->Text= szval;
    else if(StrComp(szcmd, CMD_SERSTP) ==0)
        ComboBox_COMStopBits->Text= szval;
    else if(StrComp(szcmd, CMD_SERCHK)==0)
        ComboBox_COMCheckBits->ItemIndex=StrToInt(szval);

}
void __fastcall TForm1::Button_ModifyDevIDClick(TObject *Sender)
{
    if(IsInCfg() ==0)
        return;
    AnsiString strval=Edit_DevID->Text;

    if(DTU_ConfigWrite(m_hDTU, CMD_DTUID, strval.c_str())!=1)
        ShowMessage("ʧ");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_ModifyPhoneClick(TObject *Sender)
{
    if(IsInCfg() ==0)
        return;
    AnsiString strval=Edit_Phone->Text;
    if(DTU_ConfigWrite(m_hDTU, CMD_PHON, strval.c_str())!=1)
        ShowMessage("ʧ");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_ModifyModeClick(TObject *Sender)
{
    if(IsInCfg() ==0)
        return;
    AnsiString strval=ComboBox_Mode->Text;
    if(DTU_ConfigWrite(m_hDTU, CMD_MODE, strval.c_str())!=1)
        ShowMessage("ʧ");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_ModifyBaudClick(TObject *Sender)
{
    if(IsInCfg() ==0)
        return;
    AnsiString strval=ComboBox_COMBaud->Text;
    if(DTU_ConfigWrite(m_hDTU, CMD_SERBAUD, strval.c_str())!=1)
        ShowMessage("ʧ");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_ModifyDataBitsClick(TObject *Sender)
{
    if(IsInCfg() ==0)
        return;
    AnsiString strval=ComboBox_COMDataBits->Text;
    if(DTU_ConfigWrite(m_hDTU, CMD_SERDAT, strval.c_str())!=1)
        ShowMessage("ʧ");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_ModifyStopBitsClick(TObject *Sender)
{
    if(IsInCfg() ==0)
        return;
    AnsiString strval=ComboBox_COMStopBits->Text;
    if(DTU_ConfigWrite(m_hDTU, CMD_SERSTP, strval.c_str())!=1)
        ShowMessage("ʧ");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_ModifyCheckBitsClick(TObject *Sender)
{
    if(IsInCfg() ==0)
        return;
    AnsiString strval=ComboBox_COMCheckBits->Text;
    if(DTU_ConfigWrite(m_hDTU, CMD_SERCHK, strval.c_str())!=1)
        ShowMessage("ʧ");

}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button_ServerClick(TObject *Sender)
{
	if(m_hServerDTU==0)
    {
		m_hServerDTU=DTU_AddNetServer("",StrToInt(Edit_Port->Text),"");
		if(DTU_Init(m_hServerDTU)==0)
        {
			DTU_Delete(m_hServerDTU);
			m_hServerDTU=0;
			ShowMessage("޷");
			return;
		}
		Timer_10->Enabled=True;
		Timer_11->Enabled=True;
	}
	else
    {
		if(m_hDTU!=0)
		{
			if(m_bEnterConfig==1)
				DTU_ExitConfig(m_hDTU,0);
			DTU_Uninit(m_hDTU);
			DTU_Delete(m_hDTU);
			m_hDTU=0;
			m_bEnterConfig=0;
		}
		DTU_Uninit(m_hServerDTU);
		DTU_Delete(m_hServerDTU);
		m_hServerDTU=0;
		Timer_10->Enabled=False;
		Timer_11->Enabled=False;
	}
	SetBtnState();

}
//---------------------------------------------------------------------------


void __fastcall TForm1::Timer_11Timer(TObject *Sender)
{
	if(m_hDTU!=0&&DTU_IsClientAvailable(m_hDTU)==0)
	{
		DTU_Delete(m_hDTU);
		m_hDTU=0;
		SetBtnState();
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer_10Timer(TObject *Sender)
{
    char szip[20],sztype[20],szname[30],szid[20],szphone[20];
    int port;
    HANDLE hClient=DTU_GetNewConnectedClient(m_hServerDTU);
    if(hClient!=0)
	{
		DTU_GetClientInfo(hClient,szip,&port,sztype,szname,szid,szphone);
		AddClient(hClient,szip,port,sztype,szid,szphone);
	}

}
//---------------------------------------------------------------------------

