// testsrvconfigDlg.cpp : implementation file
//

#include "stdafx.h"
#include "testsrvconfig.h"
#include "testsrvconfigDlg.h"
#include "dtucfgheader.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestsrvconfigDlg dialog

CTestsrvconfigDlg::CTestsrvconfigDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestsrvconfigDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestsrvconfigDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_hServerDTU=NULL;
	m_hDTU=NULL;
	m_bEnterConfig=0;
}

void CTestsrvconfigDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestsrvconfigDlg)
	DDX_Control(pDX, IDC_COMBO_COMSTOPBITS, m_ctlComboCOMStopBits);
	DDX_Control(pDX, IDC_COMBO_COMDATABITS, m_ctlComboCOMDataBits);
	DDX_Control(pDX, IDC_COMBO_COMCHECKBITS, m_ctlComboCOMCheckBits);
	DDX_Control(pDX, IDC_COMBO_COMBAUD, m_ctlComboCOMBaud);
	DDX_Control(pDX, IDC_COMBO_MODE, m_ctlComboMode);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestsrvconfigDlg, CDialog)
	//{{AFX_MSG_MAP(CTestsrvconfigDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_SERVER, OnButtonServer)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_ENTERCFG, OnButtonEntercfg)
	ON_BN_CLICKED(IDC_BUTTON_EXITCONFIG, OnButtonExitconfig)
	ON_BN_CLICKED(IDC_BUTTON_GETINFO, OnButtonGetinfo)
	ON_BN_CLICKED(IDC_BUTTON_MODIFYID, OnButtonModifyid)
	ON_BN_CLICKED(IDC_BUTTON_MODIFYPHONE, OnButtonModifyphone)
	ON_BN_CLICKED(IDC_BUTTON_MODIFYBAUD, OnButtonModifybaud)
	ON_BN_CLICKED(IDC_BUTTON_MODIFYMODE, OnButtonModifymode)
	ON_BN_CLICKED(IDC_BUTTON_MODIFYDATABITS, OnButtonModifydatabits)
	ON_BN_CLICKED(IDC_BUTTON_MODIFYSTOPBITS, OnButtonModifystopbits)
	ON_BN_CLICKED(IDC_BUTTON_MODIFYCHECKBITS, OnButtonModifycheckbits)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestsrvconfigDlg message handlers

BOOL CTestsrvconfigDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_ctlComboMode.SetCurSel(0);
	m_ctlComboCOMBaud.SetCurSel(8);
	m_ctlComboCOMDataBits.SetCurSel(3);
	m_ctlComboCOMCheckBits.SetCurSel(0);
	m_ctlComboCOMStopBits.SetCurSel(0);

	GetDlgItem(IDC_EDIT_PORT)->SetWindowText("4001");

	SetBtnState();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestsrvconfigDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestsrvconfigDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestsrvconfigDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTestsrvconfigDlg::OnOK() 
{
	// TODO: Add extra validation here
	
//	CDialog::OnOK();
}

void CTestsrvconfigDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	if(m_hServerDTU)
	{
		OnButtonServer();
	}
	
	CDialog::OnCancel();
}

void CTestsrvconfigDlg::OnButtonServer() 
{
	// TODO: Add your control notification handler code here
	if(m_hServerDTU==NULL)
	{
		CString str;
		GetDlgItem(IDC_EDIT_PORT)->GetWindowText(str);
		m_hServerDTU=DTU_AddNetServer(NULL,atoi(str));
		if(!DTU_Init(m_hServerDTU))
		{
			DTU_Delete(m_hServerDTU);
			m_hServerDTU=NULL;
			ShowErr("޷");
			return;
		}
		SetTimer(10,100,NULL);
		SetTimer(11,1000,NULL);		
	}
	else
	{
		if(m_hDTU!=NULL)
		{
			if(m_bEnterConfig)
				DTU_ExitConfig(m_hDTU,0);
			DTU_Uninit(m_hDTU);
			DTU_Delete(m_hDTU);
			m_hDTU=NULL;
			m_bEnterConfig=0;
		}
		DTU_Uninit(m_hServerDTU);
		DTU_Delete(m_hServerDTU);
		m_hServerDTU=NULL;
		KillTimer(10);
		KillTimer(11);
	}
	SetBtnState();
}
void CTestsrvconfigDlg::ShowErr(LPCTSTR lpmsg)
{
	MessageBox(lpmsg,"",MB_ICONSTOP|MB_OK);
}

void CTestsrvconfigDlg::SetBtnState()
{
	GetDlgItem(IDC_BUTTON_SERVER)->SetWindowText(m_hServerDTU==NULL?
		"":"ֹͣ");
	GetDlgItem(IDC_BUTTON_ENTERCFG)->EnableWindow(
		m_hDTU!=NULL&&!m_bEnterConfig);
	GetDlgItem(IDC_BUTTON_EXITCONFIG)->EnableWindow(m_hDTU!=NULL);
	GetDlgItem(IDC_BUTTON_GETINFO)->EnableWindow(
		m_hDTU!=NULL&&m_bEnterConfig);
	if(m_hDTU==NULL)
		GetDlgItem(IDC_EDIT_INFO)->SetWindowText("");
}

void CTestsrvconfigDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if(nIDEvent==10)
	{
		HANDLE hClient=DTU_GetNewConnectedClient(m_hServerDTU);
		if(hClient!=NULL)
		{
			char szip[20];
			char sztype[20],szname[30],szid[20],szphone[20];
			int port;
			DTU_GetClientInfo(hClient,szip,&port,sztype,szname,szid,szphone);
			AddClient(hClient,szip,port,sztype,szid,szphone);
		}
	}
	else if(nIDEvent==11)
	{
		if(m_hDTU!=NULL&&!DTU_IsClientAvailable(m_hDTU))
		{
			DTU_Delete(m_hDTU);
			m_hDTU=NULL;
			SetBtnState();
		}
		return;
	}
	
	CDialog::OnTimer(nIDEvent);
}

void CTestsrvconfigDlg::AddClient(HANDLE hClient, char *szip, int port,char* sztype,char* szid,char* szphone)
{
	if(m_hDTU!=NULL)
	{
		if(m_bEnterConfig)
			DTU_ExitConfig(m_hDTU,0);
		DTU_Uninit(m_hDTU);
		DTU_Delete(m_hDTU);
		m_hDTU=NULL;
		m_bEnterConfig=0;
	}
	m_hDTU=hClient;
	
	CString str="";
	str.Format("ͻ: IPַ:%s ˿:%d :%s 豸ID:%s ֻ:%s",szip,port,sztype,szid,szphone);
	GetDlgItem(IDC_EDIT_INFO)->SetWindowText(str);
	
	SetBtnState();
}

void CTestsrvconfigDlg::OnButtonEntercfg() 
{
	// TODO: Add your control notification handler code here
	if(!DTU_EnterConfig(m_hDTU))
	{
		ShowErr("޷豸");
		return;
	}
	m_bEnterConfig=1;
	SetBtnState();
}

void CTestsrvconfigDlg::OnButtonExitconfig() 
{
	// TODO: Add your control notification handler code here
	if(!DTU_ExitConfig(m_hDTU))
	{
		ShowErr("ʧ");
	}
	m_bEnterConfig=0;
	SetBtnState();
}

void CTestsrvconfigDlg::OnButtonGetinfo() 
{
	// TODO: Add your control notification handler code here
	if(!IsInCfg())
		return;
	if(!DTU_GetAllConfig(m_hDTU))
	{
		ShowErr("ȡϢʧ");
		return;
	}
	char szcmd[20],szval[50];
	CString strinfo="ȡϢ:\r\n\r\n";
	while(DTU_GetConfig(m_hDTU,szcmd,szval))
	{
		FillInfo(szcmd,szval);
		strinfo+=":";
		strinfo+=szcmd;
		strinfo+="   ֵ:";
		strinfo+=szval;
		strinfo+="\r\n";
	}
	MessageBox(strinfo);	
}

int CTestsrvconfigDlg::IsInCfg()
{
	if(!m_bEnterConfig)
		ShowErr("Ƚ״̬");
	return m_bEnterConfig;

}

void CTestsrvconfigDlg::OnButtonModifyid() 
{
	// TODO: Add your control notification handler code here
	if(!IsInCfg())
		return;
	char szval[200];
	GetDlgItem(IDC_EDIT_DEVID)->GetWindowText(szval,200);
	if(DTU_ConfigWrite(m_hDTU,CMD_DTUID,szval)!=1)
	{
		ShowErr("ʧ");
	}
}

void CTestsrvconfigDlg::OnButtonModifyphone() 
{
	// TODO: Add your control notification handler code here
	if(!IsInCfg())
		return;
	char szval[200];
	GetDlgItem(IDC_EDIT_PHONE)->GetWindowText(szval,200);
	if(DTU_ConfigWrite(m_hDTU,CMD_PHON,szval)!=1)
	{
		ShowErr("ʧ");
	}
	
}

void CTestsrvconfigDlg::OnButtonModifymode() 
{
	// TODO: Add your control notification handler code here
	if(!IsInCfg())
		return;
	char szval[200];
	GetDlgItem(IDC_COMBO_MODE)->GetWindowText(szval,200);
	if(DTU_ConfigWrite(m_hDTU,CMD_MODE,szval)!=1)
	{
		ShowErr("ʧ");
	}	
}

void CTestsrvconfigDlg::OnButtonModifybaud() 
{
	// TODO: Add your control notification handler code here
	if(!IsInCfg())
		return;
	char szval[200];
	GetDlgItem(IDC_COMBO_COMBAUD)->GetWindowText(szval,200);
	if(DTU_ConfigWrite(m_hDTU,CMD_SERBAUD,szval)!=1)
	{
		ShowErr("ʧ");
	}	
	
}

void CTestsrvconfigDlg::OnButtonModifydatabits() 
{
	// TODO: Add your control notification handler code here
	if(!IsInCfg())
		return;
	char szval[200];
	GetDlgItem(IDC_COMBO_COMDATABITS)->GetWindowText(szval,200);
	if(DTU_ConfigWrite(m_hDTU,CMD_SERDAT,szval)!=1)
	{
		ShowErr("ʧ");
	}	
	
}

void CTestsrvconfigDlg::OnButtonModifystopbits() 
{
	// TODO: Add your control notification handler code here
	if(!IsInCfg())
		return;
	char szval[200];
	GetDlgItem(IDC_COMBO_COMSTOPBITS)->GetWindowText(szval,200);
	if(DTU_ConfigWrite(m_hDTU,CMD_SERSTP,szval)!=1)
	{
		ShowErr("ʧ");
	}	
}

void CTestsrvconfigDlg::OnButtonModifycheckbits() 
{
	// TODO: Add your control notification handler code here
	if(!IsInCfg())
		return;
	char szval[200];
	sprintf(szval,"%d",m_ctlComboCOMCheckBits.GetCurSel());
	if(DTU_ConfigWrite(m_hDTU,CMD_SERCHK,szval)!=1)
	{
		ShowErr("ʧ");
	}		
}
void CTestsrvconfigDlg::FillInfo(char *szcmd, char *szval)
{
	if(!strcmp(szcmd,CMD_DTUID))
	{
		GetDlgItem(IDC_EDIT_DEVID)->SetWindowText(szval);
	}
	else if(!strcmp(szcmd,CMD_PHON))
	{
		GetDlgItem(IDC_EDIT_PHONE)->SetWindowText(szval);
	}
	else if(!strcmp(szcmd,CMD_MODE))
	{
		m_ctlComboMode.SelectString(0,(LPCTSTR)szval);
	}
	else if(!strcmp(szcmd,CMD_SERBAUD))
	{
		m_ctlComboCOMBaud.SelectString(0,(LPCTSTR)szval);
	}
	else if(!strcmp(szcmd,CMD_SERDAT))
	{
		m_ctlComboCOMDataBits.SelectString(0,(LPCTSTR)szval);
	}
	else if(!strcmp(szcmd,CMD_SERSTP))
	{
		m_ctlComboCOMStopBits.SelectString(0,(LPCTSTR)szval);
	}
	else if(!strcmp(szcmd,CMD_SERCHK))
	{
		m_ctlComboCOMCheckBits.SetCurSel(atoi(szval));
	}
	
}