unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,DTUSet, ExtCtrls;

type
  TForm1 = class(TForm)
    Button_EnterCfg: TButton;
    Button_ExitCfg: TButton;
    Button_GetInfo: TButton;
    GroupBox1: TGroupBox;
    Label6: TLabel;
    Edit_DevID: TEdit;
    Button_ModifyDevID: TButton;
    Label7: TLabel;
    Edit_Phone: TEdit;
    Button_ModifyPhone: TButton;
    Label8: TLabel;
    Button_ModifyMode: TButton;
    ComboBox_Mode: TComboBox;
    Label9: TLabel;
    ComboBox_COMBaud: TComboBox;
    Button_ModifyCOMBaud: TButton;
    Label10: TLabel;
    ComboBox_COMDataBits: TComboBox;
    Button_ModifyCOMDataBits: TButton;
    Label11: TLabel;
    ComboBox_COMStopBits: TComboBox;
    Button_ModifyCOMStopBits: TButton;
    Label12: TLabel;
    ComboBox_COMCheckBits: TComboBox;
    Button_ModifyCOMCheckBits: TButton;
    Label1: TLabel;
    Edit_Port: TEdit;
    Button_Server: TButton;
    Label_Client: TLabel;
    Timer_10: TTimer;
    Timer_11: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure Button_EnterCfgClick(Sender: TObject);
    procedure Button_ExitCfgClick(Sender: TObject);
    procedure Button_GetInfoClick(Sender: TObject);
    procedure Button_ModifyDevIDClick(Sender: TObject);
    procedure Button_ModifyPhoneClick(Sender: TObject);
    procedure Button_ModifyModeClick(Sender: TObject);
    procedure Button_ModifyCOMBaudClick(Sender: TObject);
    procedure Button_ModifyCOMDataBitsClick(Sender: TObject);
    procedure Button_ModifyCOMStopBitsClick(Sender: TObject);
    procedure Button_ModifyCOMCheckBitsClick(Sender: TObject);
    procedure OnClose(Sender: TObject; var Action: TCloseAction);
    procedure Button_ServerClick(Sender: TObject);
    procedure Timer_10Timer(Sender: TObject);
    procedure Timer_11Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    m_hDTU : integer;
    m_bEnterConfig : BYTE;
	  m_hServerDTU : integer;

  published
    procedure SetBtnState();
    procedure AddClient(hClient:integer;szip:PCHAR;port:integer;sztype,szid,szphone:PCHAR);
    function IsInCfg(): integer;
    procedure FillInfo(szcmd, szval: PCHAR);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  ComboBox_Mode.ItemIndex:= 0;
  ComboBox_COMBaud.ItemIndex:= 9;
  ComboBox_COMDataBits.ItemIndex:= 3;
  ComboBox_COMStopBits.ItemIndex:= 0;
  ComboBox_COMCheckBits.ItemIndex:= 0;

  m_hDTU := 0;
  SetBtnState ();

end;

procedure TForm1.SetBtnState();
begin
  if m_hServerDTU=0 then
    button_server.Caption:=''
  else
    button_server.Caption:='ֹͣ';

  if (m_hDTU<>0) and (m_bEnterConfig=0) then
    button_entercfg.Enabled:=True
  else
    button_entercfg.Enabled:=False;

  if m_hDTU<>0 then
    button_exitcfg.Enabled:=True
  else
    button_exitcfg.Enabled:=False;

  if (m_hDTU<>0) and (m_bEnterConfig=1) then
    button_getinfo.Enabled:=True
  else
    button_getinfo.Enabled:=False;
	if m_hDTU=0 then
    Label_Client.Caption:='';
end;

procedure TForm1.Button_EnterCfgClick(Sender: TObject);
begin
 	if DTU_EnterConfig(m_hDTU)=0 then
  begin
		ShowMessage('޷豸');
		Exit;
	end;
	m_bEnterConfig:=1;
	SetBtnState();
end;

procedure TForm1.AddClient(hClient:integer;szip:PCHAR;port:integer;sztype,szid,szphone:PCHAR);
var
strinfo:AnsiString;
begin
	if m_hDTU<>0 then
	begin
		if m_bEnterConfig=1 then
			DTU_ExitConfig(m_hDTU,0);
		DTU_Uninit(m_hDTU);
		DTU_Delete(m_hDTU);
		m_hDTU:=0;
		m_bEnterConfig:=0;
	end;
	m_hDTU:=hClient;

  strinfo:=
	'ͻ: IPַ:'+szip+' ˿:'+IntToStr(port)+' :'+sztype+' 豸ID:'+szid+' ֻ:'+szphone;
  Label_Client.Caption:=strinfo;
	SetBtnState();

end;

procedure TForm1.Button_ExitCfgClick(Sender: TObject);
begin
	if DTU_ExitConfig(m_hDTU,1)=0 then
		ShowMessage('ʧ');
	m_bEnterConfig:=0;
	SetBtnState();

end;

procedure TForm1.Button_GetInfoClick(Sender: TObject);
var
szcmd : array[0..20] of CHAR;
szval : array[0..20] of CHAR;
strinfo : AnsiString;
begin
    If IsInCfg()=0 Then
        Exit;
    If DTU_GetAllConfig(m_hDTU)=0 Then
    begin
        ShowMessage('ȡϢʧ');
        Exit;
    end;
    strinfo:='ȡϢ:\r\n\r\n';
    While(DTU_GetConfig(m_hDTU, @szcmd[0], @szval[0])=1) do
    begin
        FillInfo(szcmd, szval);
        strinfo:= strinfo + ':';
        strinfo:= strinfo +szcmd;
        strinfo:= strinfo + '   ֵ:';
        strinfo:= strinfo + szval;
        strinfo:= strinfo +'\r\n';
    end;
    ShowMessage(strinfo);

end;

function TForm1.IsInCfg(): integer;
begin
    If m_bEnterConfig = 0 Then
        ShowMessage('Ƚ״̬');
        
    IsInCfg:=m_bEnterConfig;

end;

procedure TForm1.FillInfo(szcmd,szval : PCHAR);
begin
    If StrComp(szcmd, CMD_DTUID) = 0 Then
        Edit_DevID.Text:= szval
    Else If StrComp(szcmd, CMD_PHON) = 0 Then
        Edit_Phone.Text:= szval
    Else If StrComp(szcmd, CMD_MODE) = 0 Then
        ComboBox_Mode.Text := szval
    Else If StrComp(szcmd, CMD_SERBAUD) = 0 Then
        ComboBox_COMBaud.Text := szval
    Else If StrComp(szcmd, CMD_SERDAT) = 0 Then
        ComboBox_COMDataBits.Text := szval
    Else If StrComp(szcmd, CMD_SERSTP) = 0 Then
        ComboBox_COMStopBits.Text := szval
    Else If StrComp(szcmd, CMD_SERCHK)=0 Then
        ComboBox_COMCheckBits.Text:=szval;

end;

procedure TForm1.Button_ModifyDevIDClick(Sender: TObject);
var
strval : AnsiString;
begin
    If IsInCfg() = 0 Then
        Exit;
    strval:=Edit_DevID.Text;
    If DTU_ConfigWrite(m_hDTU, CMD_DTUID, PCHAR(strval))<>1 Then
        ShowMessage('ʧ');

end;

procedure TForm1.Button_ModifyPhoneClick(Sender: TObject);
var
strval : AnsiString;
begin
    If IsInCfg() = 0 Then
        Exit;
    strval:=Edit_Phone.Text;
    If DTU_ConfigWrite(m_hDTU, CMD_PHON, PCHAR(strval))<>1 Then
        ShowMessage('ʧ');

end;

procedure TForm1.Button_ModifyModeClick(Sender: TObject);
var
strval : AnsiString;
begin
    If IsInCfg() = 0 Then
        Exit;
    strval:=ComboBox_Mode.Text;
    If DTU_ConfigWrite(m_hDTU, CMD_MODE, PCHAR(strval))<>1 Then
        ShowMessage('ʧ');

end;

procedure TForm1.Button_ModifyCOMBaudClick(Sender: TObject);
var
strval : AnsiString;
begin
    If IsInCfg() = 0 Then
        Exit;
    strval:=ComboBox_COMBaud.Text;
    If DTU_ConfigWrite(m_hDTU, CMD_SERBAUD, PCHAR(strval))<>1 Then
        ShowMessage('ʧ');

end;

procedure TForm1.Button_ModifyCOMDataBitsClick(Sender: TObject);
var
strval : AnsiString;
begin
   If IsInCfg() = 0 Then
        Exit;
    strval:=ComboBox_COMDataBits.Text;
    If DTU_ConfigWrite(m_hDTU, CMD_SERDAT, PCHAR(strval))<>1 Then
        ShowMessage('ʧ');

end;

procedure TForm1.Button_ModifyCOMStopBitsClick(Sender: TObject);
var
strval : AnsiString;
begin
   If IsInCfg() = 0 Then
        Exit;
    strval:=ComboBox_COMStopBits.Text;
    If DTU_ConfigWrite(m_hDTU, CMD_SERSTP, PCHAR(strval))<>1 Then
        ShowMessage('ʧ');

end;

procedure TForm1.Button_ModifyCOMCheckBitsClick(Sender: TObject);
var
strval : AnsiString;
begin
   If IsInCfg() = 0 Then
        Exit;
    strval:=ComboBox_COMCheckBits.Text;
    If DTU_ConfigWrite(m_hDTU, CMD_SERCHK, PCHAR(strval))<>1 Then
        ShowMessage('ʧ');

end;

procedure TForm1.OnClose(Sender: TObject; var Action: TCloseAction);
begin
	if m_hServerDTU<>0 then
		Button_ServerClick(Sender);

end;

procedure TForm1.Button_ServerClick(Sender: TObject);
begin
	if m_hServerDTU=0 then
  begin
		m_hServerDTU:=DTU_AddNetServer('',StrToInt(edit_port.Text),'');
		if DTU_Init(m_hServerDTU)=0 then
    begin
			DTU_Delete(m_hServerDTU);
			m_hServerDTU:=0;
			ShowMessage('޷');
			Exit;
		end;
		timer_10.Enabled:=True;
		timer_11.Enabled:=True;
	end
	else
  begin
		if m_hDTU<>0 then
		begin
			if m_bEnterConfig=1 then
				DTU_ExitConfig(m_hDTU,0);
			DTU_Uninit(m_hDTU);
			DTU_Delete(m_hDTU);
			m_hDTU:=0;
			m_bEnterConfig:=0;
		end;
		DTU_Uninit(m_hServerDTU);
		DTU_Delete(m_hServerDTU);
		m_hServerDTU:=0;
		timer_10.Enabled:=False;
		timer_11.Enabled:=False;
	end;
	SetBtnState();
end;

procedure TForm1.Timer_10Timer(Sender: TObject);
var
hClient : integer;
szip : array[0..20] of BYTE;
sztype : array[0..20] of BYTE;
szid : array[0..20] of BYTE;
szname : array[0..30] of BYTE;
szphone : array[0..20] of BYTE;
port : integer;
begin
    hClient:=DTU_GetNewConnectedClient(m_hServerDTU);
		if hClient<>0 then
		begin
			DTU_GetClientInfo(hClient,@szip[0],@port,@sztype[0],@szname[0],@szid[0],@szphone[0]);
			AddClient(hClient,@szip[0],port,@sztype[0],@szid[0],@szphone[0]);
		end;

end;

procedure TForm1.Timer_11Timer(Sender: TObject);
begin
		if (m_hDTU<>0) and (DTU_IsClientAvailable(m_hDTU)=0) then
		begin
			DTU_Delete(m_hDTU);
			m_hDTU:=0;
			SetBtnState();
		end;

end;

end.
